<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<meta name="robots" content="NOINDEX, NOFOLLOW" /> <!-- Prevent indexing by search engines -->
<title>ARM Compute Library: TensorShape Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script><script type="text/javascript" src="http://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">ARM Compute Library
   &#160;<span id="projectnumber">17.04</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.xhtml"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.xhtml"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.xhtml"><span>Data&#160;Structures</span></a></li>
      <li><a href="files.xhtml"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.xhtml"><span>Data&#160;Structures</span></a></li>
      <li><a href="classes.xhtml"><span>Data&#160;Structure&#160;Index</span></a></li>
      <li><a href="inherits.xhtml"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.xhtml"><span>Data&#160;Fields</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('classarm__compute_1_1_tensor_shape.xhtml','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">TensorShape Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Shape of a tensor.  
 <a href="classarm__compute_1_1_tensor_shape.xhtml#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_tensor_shape_8h_source.xhtml">TensorShape.h</a>&gt;</code></p>
<div class="dynheader">
Collaboration diagram for TensorShape:</div>
<div class="dyncontent">
<div class="center"><iframe scrolling="no" frameborder="0" src="classarm__compute_1_1_tensor_shape__coll__graph.svg" width="162" height="203"><p><b>This browser is not able to show SVG: try Firefox, Chrome, Safari, or Opera instead.</b></p></iframe>
</div>
<center><span class="legend">[<a target="top" href="graph_legend.xhtml">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:af156b289692f8c3f64688e9a2932ae78"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_tensor_shape.xhtml#af156b289692f8c3f64688e9a2932ae78">TensorShape</a> (const <a class="el" href="classarm__compute_1_1_tensor_shape.xhtml">TensorShape</a> &amp;)=default</td></tr>
<tr class="memdesc:af156b289692f8c3f64688e9a2932ae78"><td class="mdescLeft">&#160;</td><td class="mdescRight">Allow instances of this class to be copy constructed.  <a href="#af156b289692f8c3f64688e9a2932ae78">More...</a><br /></td></tr>
<tr class="separator:af156b289692f8c3f64688e9a2932ae78"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a355b1a84ab7af3b8ef9a6bea1939450a"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classarm__compute_1_1_tensor_shape.xhtml">TensorShape</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_tensor_shape.xhtml#a355b1a84ab7af3b8ef9a6bea1939450a">operator=</a> (const <a class="el" href="classarm__compute_1_1_tensor_shape.xhtml">TensorShape</a> &amp;)=default</td></tr>
<tr class="memdesc:a355b1a84ab7af3b8ef9a6bea1939450a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Allow instances of this class to be copied.  <a href="#a355b1a84ab7af3b8ef9a6bea1939450a">More...</a><br /></td></tr>
<tr class="separator:a355b1a84ab7af3b8ef9a6bea1939450a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5fa5abfb10a67d23a75339646e84517a"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_tensor_shape.xhtml#a5fa5abfb10a67d23a75339646e84517a">TensorShape</a> (<a class="el" href="classarm__compute_1_1_tensor_shape.xhtml">TensorShape</a> &amp;&amp;)=default</td></tr>
<tr class="memdesc:a5fa5abfb10a67d23a75339646e84517a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Allow instances of this class to be move constructed.  <a href="#a5fa5abfb10a67d23a75339646e84517a">More...</a><br /></td></tr>
<tr class="separator:a5fa5abfb10a67d23a75339646e84517a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afbfae7c97606fb71d556a9f4e46dda00"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classarm__compute_1_1_tensor_shape.xhtml">TensorShape</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_tensor_shape.xhtml#afbfae7c97606fb71d556a9f4e46dda00">operator=</a> (<a class="el" href="classarm__compute_1_1_tensor_shape.xhtml">TensorShape</a> &amp;&amp;)=default</td></tr>
<tr class="memdesc:afbfae7c97606fb71d556a9f4e46dda00"><td class="mdescLeft">&#160;</td><td class="mdescRight">Allow instances of this class to be moved.  <a href="#afbfae7c97606fb71d556a9f4e46dda00">More...</a><br /></td></tr>
<tr class="separator:afbfae7c97606fb71d556a9f4e46dda00"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a29ff524f0e3378fb25a8447bdeed6ba9"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_tensor_shape.xhtml#a29ff524f0e3378fb25a8447bdeed6ba9">~TensorShape</a> ()=default</td></tr>
<tr class="memdesc:a29ff524f0e3378fb25a8447bdeed6ba9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Default destructor.  <a href="#a29ff524f0e3378fb25a8447bdeed6ba9">More...</a><br /></td></tr>
<tr class="separator:a29ff524f0e3378fb25a8447bdeed6ba9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4eaec01ba2c12093db609d1034ad0bc1"><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_tensor_shape.xhtml#a4eaec01ba2c12093db609d1034ad0bc1">total_size</a> () const </td></tr>
<tr class="memdesc:a4eaec01ba2c12093db609d1034ad0bc1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Collapses all dimensions to a single linear total size.  <a href="#a4eaec01ba2c12093db609d1034ad0bc1">More...</a><br /></td></tr>
<tr class="separator:a4eaec01ba2c12093db609d1034ad0bc1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a91d8061f66e7f8bc56da91d965f04376"><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_tensor_shape.xhtml#a91d8061f66e7f8bc56da91d965f04376">total_size_upper</a> (size_t dimension) const </td></tr>
<tr class="memdesc:a91d8061f66e7f8bc56da91d965f04376"><td class="mdescLeft">&#160;</td><td class="mdescRight">Collapses given dimension and above.  <a href="#a91d8061f66e7f8bc56da91d965f04376">More...</a><br /></td></tr>
<tr class="separator:a91d8061f66e7f8bc56da91d965f04376"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classarm__compute_1_1_dimensions"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classarm__compute_1_1_dimensions')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classarm__compute_1_1_dimensions.xhtml">Dimensions&lt; size_t &gt;</a></td></tr>
<tr class="memitem:a0d3c59537291735849c740364496a41c inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_dimensions.xhtml#a0d3c59537291735849c740364496a41c">Dimensions</a> (const <a class="el" href="classarm__compute_1_1_dimensions.xhtml">Dimensions</a> &amp;)=default</td></tr>
<tr class="memdesc:a0d3c59537291735849c740364496a41c inherit pub_methods_classarm__compute_1_1_dimensions"><td class="mdescLeft">&#160;</td><td class="mdescRight">Allow instances of this class to be copy constructed.  <a href="#a0d3c59537291735849c740364496a41c">More...</a><br /></td></tr>
<tr class="separator:a0d3c59537291735849c740364496a41c inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa2c609345b3b6fa8da2486f75fff8ed8 inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_dimensions.xhtml#aa2c609345b3b6fa8da2486f75fff8ed8">Dimensions</a> (<a class="el" href="classarm__compute_1_1_dimensions.xhtml">Dimensions</a> &amp;&amp;)=default</td></tr>
<tr class="memdesc:aa2c609345b3b6fa8da2486f75fff8ed8 inherit pub_methods_classarm__compute_1_1_dimensions"><td class="mdescLeft">&#160;</td><td class="mdescRight">Allow instances of this class to be move constructed.  <a href="#aa2c609345b3b6fa8da2486f75fff8ed8">More...</a><br /></td></tr>
<tr class="separator:aa2c609345b3b6fa8da2486f75fff8ed8 inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2c96e96e2d005b4a8b66c2acd1688903 inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classarm__compute_1_1_dimensions.xhtml">Dimensions</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_dimensions.xhtml#a2c96e96e2d005b4a8b66c2acd1688903">operator=</a> (const <a class="el" href="classarm__compute_1_1_dimensions.xhtml">Dimensions</a> &amp;)=default</td></tr>
<tr class="memdesc:a2c96e96e2d005b4a8b66c2acd1688903 inherit pub_methods_classarm__compute_1_1_dimensions"><td class="mdescLeft">&#160;</td><td class="mdescRight">Allow instances of this class to be copied.  <a href="#a2c96e96e2d005b4a8b66c2acd1688903">More...</a><br /></td></tr>
<tr class="separator:a2c96e96e2d005b4a8b66c2acd1688903 inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a80565e11a35c48747bcc2cba06931e20 inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classarm__compute_1_1_dimensions.xhtml">Dimensions</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_dimensions.xhtml#a80565e11a35c48747bcc2cba06931e20">operator=</a> (<a class="el" href="classarm__compute_1_1_dimensions.xhtml">Dimensions</a> &amp;&amp;)=default</td></tr>
<tr class="memdesc:a80565e11a35c48747bcc2cba06931e20 inherit pub_methods_classarm__compute_1_1_dimensions"><td class="mdescLeft">&#160;</td><td class="mdescRight">Allow instances of this class to be moved.  <a href="#a80565e11a35c48747bcc2cba06931e20">More...</a><br /></td></tr>
<tr class="separator:a80565e11a35c48747bcc2cba06931e20 inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab5908ac7ee6593782fd6ec6caa0b70ff inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_dimensions.xhtml#ab5908ac7ee6593782fd6ec6caa0b70ff">~Dimensions</a> ()=0</td></tr>
<tr class="memdesc:ab5908ac7ee6593782fd6ec6caa0b70ff inherit pub_methods_classarm__compute_1_1_dimensions"><td class="mdescLeft">&#160;</td><td class="mdescRight">Pure virtual destructor.  <a href="#ab5908ac7ee6593782fd6ec6caa0b70ff">More...</a><br /></td></tr>
<tr class="separator:ab5908ac7ee6593782fd6ec6caa0b70ff inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a982730e6f0da5f9490f59bc5f6bb3f27 inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_dimensions.xhtml#a982730e6f0da5f9490f59bc5f6bb3f27">set</a> (size_t dimension, size_tvalue)</td></tr>
<tr class="memdesc:a982730e6f0da5f9490f59bc5f6bb3f27 inherit pub_methods_classarm__compute_1_1_dimensions"><td class="mdescLeft">&#160;</td><td class="mdescRight">Accessor to set the value of one of the dimensions.  <a href="#a982730e6f0da5f9490f59bc5f6bb3f27">More...</a><br /></td></tr>
<tr class="separator:a982730e6f0da5f9490f59bc5f6bb3f27 inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afb5cd37bb08f1029691590372e6330f0 inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_dimensions.xhtml#afb5cd37bb08f1029691590372e6330f0">x</a> () const</td></tr>
<tr class="memdesc:afb5cd37bb08f1029691590372e6330f0 inherit pub_methods_classarm__compute_1_1_dimensions"><td class="mdescLeft">&#160;</td><td class="mdescRight">Alias to access the size of the first dimension.  <a href="#afb5cd37bb08f1029691590372e6330f0">More...</a><br /></td></tr>
<tr class="separator:afb5cd37bb08f1029691590372e6330f0 inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a691c9cb93365c2e33f3429de43244098 inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_dimensions.xhtml#a691c9cb93365c2e33f3429de43244098">y</a> () const</td></tr>
<tr class="memdesc:a691c9cb93365c2e33f3429de43244098 inherit pub_methods_classarm__compute_1_1_dimensions"><td class="mdescLeft">&#160;</td><td class="mdescRight">Alias to access the size of the second dimension.  <a href="#a691c9cb93365c2e33f3429de43244098">More...</a><br /></td></tr>
<tr class="separator:a691c9cb93365c2e33f3429de43244098 inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a336121cb63ed79fa0a072eed03d694ac inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_dimensions.xhtml#a336121cb63ed79fa0a072eed03d694ac">z</a> () const</td></tr>
<tr class="memdesc:a336121cb63ed79fa0a072eed03d694ac inherit pub_methods_classarm__compute_1_1_dimensions"><td class="mdescLeft">&#160;</td><td class="mdescRight">Alias to access the size of the third dimension.  <a href="#a336121cb63ed79fa0a072eed03d694ac">More...</a><br /></td></tr>
<tr class="separator:a336121cb63ed79fa0a072eed03d694ac inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a67306b78d448f2ec131a237513572bac inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_dimensions.xhtml#a67306b78d448f2ec131a237513572bac">operator[]</a> (size_t dimension) const</td></tr>
<tr class="memdesc:a67306b78d448f2ec131a237513572bac inherit pub_methods_classarm__compute_1_1_dimensions"><td class="mdescLeft">&#160;</td><td class="mdescRight">Generic accessor to get the size of any dimension.  <a href="#a67306b78d448f2ec131a237513572bac">More...</a><br /></td></tr>
<tr class="separator:a67306b78d448f2ec131a237513572bac inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0f59f175e7682c7ed5f4ea30ef687834 inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memItemLeft" align="right" valign="top">unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_dimensions.xhtml#a0f59f175e7682c7ed5f4ea30ef687834">num_dimensions</a> () const</td></tr>
<tr class="memdesc:a0f59f175e7682c7ed5f4ea30ef687834 inherit pub_methods_classarm__compute_1_1_dimensions"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the effective dimensionality of the tensor.  <a href="#a0f59f175e7682c7ed5f4ea30ef687834">More...</a><br /></td></tr>
<tr class="separator:a0f59f175e7682c7ed5f4ea30ef687834 inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a810a78f0b7cc0270f38d4136e023ea3b inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_dimensions.xhtml#a810a78f0b7cc0270f38d4136e023ea3b">set_num_dimensions</a> (size_t <a class="el" href="classarm__compute_1_1_dimensions.xhtml#a0f59f175e7682c7ed5f4ea30ef687834">num_dimensions</a>)</td></tr>
<tr class="memdesc:a810a78f0b7cc0270f38d4136e023ea3b inherit pub_methods_classarm__compute_1_1_dimensions"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set number of dimensions.  <a href="#a810a78f0b7cc0270f38d4136e023ea3b">More...</a><br /></td></tr>
<tr class="separator:a810a78f0b7cc0270f38d4136e023ea3b inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab2878b67ca384a699c1270900b31290b inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memItemLeft" align="right" valign="top">std::array&lt; size_t, <a class="el" href="classarm__compute_1_1_dimensions.xhtml#a1b67d5b720119d50faa286c774579ecc">num_max_dimensions</a> &gt;::iterator&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_dimensions.xhtml#ab2878b67ca384a699c1270900b31290b">begin</a> ()</td></tr>
<tr class="memdesc:ab2878b67ca384a699c1270900b31290b inherit pub_methods_classarm__compute_1_1_dimensions"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a read/write iterator that points to the first element in the dimension array.  <a href="#ab2878b67ca384a699c1270900b31290b">More...</a><br /></td></tr>
<tr class="separator:ab2878b67ca384a699c1270900b31290b inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aeade0eaf149acac842e98d99d37e39c7 inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memItemLeft" align="right" valign="top">std::array&lt; size_t, <a class="el" href="classarm__compute_1_1_dimensions.xhtml#a1b67d5b720119d50faa286c774579ecc">num_max_dimensions</a> &gt;::const_iterator&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_dimensions.xhtml#aeade0eaf149acac842e98d99d37e39c7">begin</a> () const</td></tr>
<tr class="memdesc:aeade0eaf149acac842e98d99d37e39c7 inherit pub_methods_classarm__compute_1_1_dimensions"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a read-only (constant) iterator that points to the first element in the dimension array.  <a href="#aeade0eaf149acac842e98d99d37e39c7">More...</a><br /></td></tr>
<tr class="separator:aeade0eaf149acac842e98d99d37e39c7 inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4498730adaf901d945c12841df994bba inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memItemLeft" align="right" valign="top">std::array&lt; size_t, <a class="el" href="classarm__compute_1_1_dimensions.xhtml#a1b67d5b720119d50faa286c774579ecc">num_max_dimensions</a> &gt;::const_iterator&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_dimensions.xhtml#a4498730adaf901d945c12841df994bba">cbegin</a> () const</td></tr>
<tr class="memdesc:a4498730adaf901d945c12841df994bba inherit pub_methods_classarm__compute_1_1_dimensions"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a read-only (constant) iterator that points to the first element in the dimension array.  <a href="#a4498730adaf901d945c12841df994bba">More...</a><br /></td></tr>
<tr class="separator:a4498730adaf901d945c12841df994bba inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac684b52c6197edff9cccb3abd1e41f59 inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memItemLeft" align="right" valign="top">std::array&lt; size_t, <a class="el" href="classarm__compute_1_1_dimensions.xhtml#a1b67d5b720119d50faa286c774579ecc">num_max_dimensions</a> &gt;::iterator&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_dimensions.xhtml#ac684b52c6197edff9cccb3abd1e41f59">end</a> ()</td></tr>
<tr class="memdesc:ac684b52c6197edff9cccb3abd1e41f59 inherit pub_methods_classarm__compute_1_1_dimensions"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a read/write iterator that points one past the last element in the dimension array.  <a href="#ac684b52c6197edff9cccb3abd1e41f59">More...</a><br /></td></tr>
<tr class="separator:ac684b52c6197edff9cccb3abd1e41f59 inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a819e633cd63b404cf9938bc6e755c170 inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memItemLeft" align="right" valign="top">std::array&lt; size_t, <a class="el" href="classarm__compute_1_1_dimensions.xhtml#a1b67d5b720119d50faa286c774579ecc">num_max_dimensions</a> &gt;::const_iterator&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_dimensions.xhtml#a819e633cd63b404cf9938bc6e755c170">end</a> () const</td></tr>
<tr class="memdesc:a819e633cd63b404cf9938bc6e755c170 inherit pub_methods_classarm__compute_1_1_dimensions"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a read-only (constant) iterator that points one past the last element in the dimension array.  <a href="#a819e633cd63b404cf9938bc6e755c170">More...</a><br /></td></tr>
<tr class="separator:a819e633cd63b404cf9938bc6e755c170 inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adf9b6d55d708c285d58511a780e937fc inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memItemLeft" align="right" valign="top">std::array&lt; size_t, <a class="el" href="classarm__compute_1_1_dimensions.xhtml#a1b67d5b720119d50faa286c774579ecc">num_max_dimensions</a> &gt;::const_iterator&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_dimensions.xhtml#adf9b6d55d708c285d58511a780e937fc">cend</a> () const</td></tr>
<tr class="memdesc:adf9b6d55d708c285d58511a780e937fc inherit pub_methods_classarm__compute_1_1_dimensions"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a read-only (constant) iterator that points one past the last element in the dimension array.  <a href="#adf9b6d55d708c285d58511a780e937fc">More...</a><br /></td></tr>
<tr class="separator:adf9b6d55d708c285d58511a780e937fc inherit pub_methods_classarm__compute_1_1_dimensions"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pub_static_attribs_classarm__compute_1_1_dimensions"><td colspan="2" onclick="javascript:toggleInherit('pub_static_attribs_classarm__compute_1_1_dimensions')"><img src="closed.png" alt="-"/>&#160;Static Public Attributes inherited from <a class="el" href="classarm__compute_1_1_dimensions.xhtml">Dimensions&lt; size_t &gt;</a></td></tr>
<tr class="memitem:a1b67d5b720119d50faa286c774579ecc inherit pub_static_attribs_classarm__compute_1_1_dimensions"><td class="memItemLeft" align="right" valign="top">static constexpr size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_dimensions.xhtml#a1b67d5b720119d50faa286c774579ecc">num_max_dimensions</a></td></tr>
<tr class="memdesc:a1b67d5b720119d50faa286c774579ecc inherit pub_static_attribs_classarm__compute_1_1_dimensions"><td class="mdescLeft">&#160;</td><td class="mdescRight">Number of dimensions the tensor has.  <a href="#a1b67d5b720119d50faa286c774579ecc">More...</a><br /></td></tr>
<tr class="separator:a1b67d5b720119d50faa286c774579ecc inherit pub_static_attribs_classarm__compute_1_1_dimensions"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Shape of a tensor. </p>

<p>Definition at line <a class="el" href="_tensor_shape_8h_source.xhtml#l00038">38</a> of file <a class="el" href="_tensor_shape_8h_source.xhtml">TensorShape.h</a>.</p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="af156b289692f8c3f64688e9a2932ae78"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classarm__compute_1_1_tensor_shape.xhtml">TensorShape</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classarm__compute_1_1_tensor_shape.xhtml">TensorShape</a> &amp;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">default</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Allow instances of this class to be copy constructed. </p>

</div>
</div>
<a class="anchor" id="a5fa5abfb10a67d23a75339646e84517a"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classarm__compute_1_1_tensor_shape.xhtml">TensorShape</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classarm__compute_1_1_tensor_shape.xhtml">TensorShape</a> &amp;&amp;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">default</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Allow instances of this class to be move constructed. </p>

</div>
</div>
<a class="anchor" id="a29ff524f0e3378fb25a8447bdeed6ba9"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">~<a class="el" href="classarm__compute_1_1_tensor_shape.xhtml">TensorShape</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">default</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Default destructor. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a355b1a84ab7af3b8ef9a6bea1939450a"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classarm__compute_1_1_tensor_shape.xhtml">TensorShape</a>&amp; operator= </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classarm__compute_1_1_tensor_shape.xhtml">TensorShape</a> &amp;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">default</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Allow instances of this class to be copied. </p>

</div>
</div>
<a class="anchor" id="afbfae7c97606fb71d556a9f4e46dda00"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classarm__compute_1_1_tensor_shape.xhtml">TensorShape</a>&amp; operator= </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classarm__compute_1_1_tensor_shape.xhtml">TensorShape</a> &amp;&amp;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">default</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Allow instances of this class to be moved. </p>

</div>
</div>
<a class="anchor" id="a4eaec01ba2c12093db609d1034ad0bc1"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">size_t total_size </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Collapses all dimensions to a single linear total size. </p>
<dl class="section return"><dt>Returns</dt><dd>The total tensor size in terms of elements. </dd></dl>

<p>Definition at line <a class="el" href="_tensor_shape_8h_source.xhtml#l00068">68</a> of file <a class="el" href="_tensor_shape_8h_source.xhtml">TensorShape.h</a>.</p>

<p>References <a class="el" href="accumulate_8cl_source.xhtml#l00041">accumulate()</a>, and <a class="el" href="_error_8h_source.xhtml#l00100">ARM_COMPUTE_ERROR_ON</a>.</p>
<div class="fragment"><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    {</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">size_t</span> size = <a class="code" href="accumulate_8cl.xhtml#a00e540076dd545ad59ac7482f8cdf514">std::accumulate</a>(_id.begin(), _id.end(), 1, std::multiplies&lt;size_t&gt;());</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        <a class="code" href="_error_8h.xhtml#a54a6080c9f4df1f908e57a9bbb46f5da">ARM_COMPUTE_ERROR_ON</a>(0 == size);</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        <span class="keywordflow">return</span> size;</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    }</div><div class="ttc" id="_error_8h_xhtml_a54a6080c9f4df1f908e57a9bbb46f5da"><div class="ttname"><a href="_error_8h.xhtml#a54a6080c9f4df1f908e57a9bbb46f5da">ARM_COMPUTE_ERROR_ON</a></div><div class="ttdeci">#define ARM_COMPUTE_ERROR_ON(cond)</div><div class="ttdoc">If the condition is true then an error message is printed and an exception thrown. </div><div class="ttdef"><b>Definition:</b> <a href="_error_8h_source.xhtml#l00100">Error.h:100</a></div></div>
<div class="ttc" id="accumulate_8cl_xhtml_a00e540076dd545ad59ac7482f8cdf514"><div class="ttname"><a href="accumulate_8cl.xhtml#a00e540076dd545ad59ac7482f8cdf514">accumulate</a></div><div class="ttdeci">__kernel void accumulate(__global uchar *input_ptr, uint input_stride_x, uint input_step_x, uint input_stride_y, uint input_step_y, uint input_offset_first_element_in_bytes, __global uchar *accu_ptr, uint accu_stride_x, uint accu_step_x, uint accu_stride_y, uint accu_step_y, uint accu_offset_first_element_in_bytes)</div><div class="ttdoc">This function accumulates an input image into output image. </div><div class="ttdef"><b>Definition:</b> <a href="accumulate_8cl_source.xhtml#l00041">accumulate.cl:41</a></div></div>
</div><!-- fragment -->
</div>
</div>
<a class="anchor" id="a91d8061f66e7f8bc56da91d965f04376"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">size_t total_size_upper </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>dimension</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Collapses given dimension and above. </p>
<dl class="section note"><dt>Note</dt><dd>Precondition: dimension &lt; <a class="el" href="classarm__compute_1_1_dimensions.xhtml#a1b67d5b720119d50faa286c774579ecc" title="Number of dimensions the tensor has. ">TensorShape::num_max_dimensions</a></dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">dimension</td><td>Size of the wanted dimension</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The linear size of the collapsed dimensions </dd></dl>

<p>Definition at line <a class="el" href="_tensor_shape_8h_source.xhtml#l00082">82</a> of file <a class="el" href="_tensor_shape_8h_source.xhtml">TensorShape.h</a>.</p>

<p>References <a class="el" href="accumulate_8cl_source.xhtml#l00041">accumulate()</a>, and <a class="el" href="_error_8h_source.xhtml#l00100">ARM_COMPUTE_ERROR_ON</a>.</p>
<div class="fragment"><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    {</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">size_t</span> size = <a class="code" href="accumulate_8cl.xhtml#a00e540076dd545ad59ac7482f8cdf514">std::accumulate</a>(_id.begin() + dimension, _id.end(), 1, std::multiplies&lt;size_t&gt;());</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;        <a class="code" href="_error_8h.xhtml#a54a6080c9f4df1f908e57a9bbb46f5da">ARM_COMPUTE_ERROR_ON</a>(0 == size);</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;        <span class="keywordflow">return</span> size;</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    }</div><div class="ttc" id="_error_8h_xhtml_a54a6080c9f4df1f908e57a9bbb46f5da"><div class="ttname"><a href="_error_8h.xhtml#a54a6080c9f4df1f908e57a9bbb46f5da">ARM_COMPUTE_ERROR_ON</a></div><div class="ttdeci">#define ARM_COMPUTE_ERROR_ON(cond)</div><div class="ttdoc">If the condition is true then an error message is printed and an exception thrown. </div><div class="ttdef"><b>Definition:</b> <a href="_error_8h_source.xhtml#l00100">Error.h:100</a></div></div>
<div class="ttc" id="accumulate_8cl_xhtml_a00e540076dd545ad59ac7482f8cdf514"><div class="ttname"><a href="accumulate_8cl.xhtml#a00e540076dd545ad59ac7482f8cdf514">accumulate</a></div><div class="ttdeci">__kernel void accumulate(__global uchar *input_ptr, uint input_stride_x, uint input_step_x, uint input_stride_y, uint input_step_y, uint input_offset_first_element_in_bytes, __global uchar *accu_ptr, uint accu_stride_x, uint accu_step_x, uint accu_stride_y, uint accu_step_y, uint accu_offset_first_element_in_bytes)</div><div class="ttdoc">This function accumulates an input image into output image. </div><div class="ttdef"><b>Definition:</b> <a href="accumulate_8cl_source.xhtml#l00041">accumulate.cl:41</a></div></div>
</div><!-- fragment -->
</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>arm_compute/core/<a class="el" href="_tensor_shape_8h_source.xhtml">TensorShape.h</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespacearm__compute.xhtml">arm_compute</a></li><li class="navelem"><a class="el" href="classarm__compute_1_1_tensor_shape.xhtml">TensorShape</a></li>
    <li class="footer">Generated on Wed Apr 12 2017 17:30:10 for ARM Compute Library by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
